<template>
  <div>
    <Card>
      <p slot="title">
        <Icon type="ios-film-outline"></Icon>
        Графическая связь
      </p>

      <a href="#" slot="extra" @click.prevent="loadData">
        <Icon type="ios-loop-strong"></Icon>
        Обновить
      </a>

      <a href="#" slot="extra" @click.prevent="saveData">
        <Icon type="ios-loop-strong"></Icon>
        Сохранить
      </a>

      <simple-flowchart :scene.sync="config" :height="400"
                        @nodeClick.self="nodeClick"
                        @nodeDelete="nodeDelete"
                        @linkBreak="linkBreak"
                        @linkAdded="linkAdded"
                        @canvasClick="canvasClick"
      >
      </simple-flowchart>
    </Card>
    <Card>
      <p slot="title">
        <Icon type="ios-film-outline"></Icon>
        Редактирование задач
      </p>

      <i-form ref="form" :model="task" :label-width="80">
        <FormItem label="Имя задачи">
          <i-input v-model="task.name"></i-input>
        </FormItem>

        <FormItem label="Bash">
          <i-input type="textarea" v-model="task.command" clearable></i-input>
        </FormItem>
        <FormItem label="Прервать">
          <InputNumber v-model="task.timeout"></InputNumber>
          <label>Секунда</label>
        </FormItem>

        <FormItem label="Включить ведение журнала">
          <i-switch v-model="task.log_enable"></i-switch>
        </FormItem>

        <FormItem label="Отключить задачу">
          <i-switch v-model="task.disable"></i-switch>
        </FormItem>

        <FormItem label="Список действий">
          <i-input v-model="task.directory"></i-input>
        </FormItem>

        <FormItem>
          <i-button type="primary" @click="putTask">{{ btnText }}</i-button>
          &nbsp;
          <i-button type="error" @click="confirmRemove">Стереть</i-button>
        </FormItem>

      </i-form>
    </Card>
  </div>
</template>

<script>
import SimpleFlowchart from 'vue-simple-flowchart'
import 'vue-simple-flowchart/dist/vue-flowchart.css'

import { getRelations, addRelation, deleteRelation } from '@/api/relation'
import { putTask, getTask, deleteTask } from '@/api/task'
import { putNodes } from '@/api/node'

export default {
  components: { SimpleFlowchart },
  name: 'ContainerConfig',
  mounted: function () {
    this.loadData()
  },
  data () {
    return {
      isAdd: true,
      cid: 0,
      config: {
        centerX: 0,
        centerY: 0,
        scale: 1,
        nodes: [],
        links: []
      },
      container: {
        cid: 0,
        name: '',
        expression: '',
        disable: false
      },
      task: {
        tid: 0,
        name: '',
        expression: '',
        cid: 1,
        command: '',
        timeout: 0,
        log_enable: false,
        disable: false,
        directory: '',
        point_x: 0,
        point_y: 0
      },
      relation: {
        tid: 0,
        next_tid: 0
      },
      status: {
        1: 'Ожидание',
        2: 'Начало',
        3: 'Успешно',
        4: 'Неудача'
      },
      disableTid: true,
      btnText: 'Новое'
    }
  },
  methods: {
    convertNodes: function (nodes) {
      let arr = []
      let node
      let start = 0
      let stage = 1
      let padding = 100
      for (node of nodes) {
        start += 100
        let tmp = {}
        tmp.id = node.id

        if (node.x === 0) {
          tmp.x = start + stage * padding
        } else {
          tmp.x = node.x
        }

        if (node.y === 0) {
          tmp.y = 20 + stage * padding
        } else {
          tmp.y = node.y
        }
        tmp.type = this.getNodeTitle(node)
        tmp.label = node.name
        arr.push(tmp)
      }
      return arr
    },

    getNodeTitle: function (node) {
      let texts = []
      texts.push('[')
      texts.push(node.id.toString())
      texts.push(']')
      texts.push(this.status[node.status])
      return texts.join('')
    },

    convertLinks: function (links) {
      let arr = []
      for (let i = 0; i < links.length; i++) {
        let temp = {}
        let link = links[i]
        temp.id = link.id
        temp.from = link.tid
        temp.rid = link.id
        temp.to = link.next_tid
        arr.push(temp)
      }
      return arr
    },

    confirmRemove: function () {
      this.$Modal.confirm({
        title: 'Подтвердить',
        content: '<p>Удалить текущую задачу?</p>',
        onOk: () => {
          deleteTask(this.task.tid).then(() => {
            this.$Message.success('Успешно удалено!')
            this.loadData()
          })
        }
      })
    },
    // Нажмите на интерфейс изображения
    canvasClick: function (event) {
      // Подтвердите, что объект щелчка текущего события исходит сам по себе, а не из пузырящегося события      let target = event.target.nodeName.toLowerCase()
      if (target !== 'svg') {
        return
      }
      this.btnText = 'Новое'
      this.isAdd = true
      this.task.tid = 0
    },
    // Щелчок по узлу
    nodeClick: function (taskid) {
      this.isAdd = false
      this.btnText = 'Обновить'
      getTask(taskid).then((data) => {
        this.task = data
      })
    },

    // Подтвердить удаление
    nodeDelete: function (taskid) {
      this.$Modal.confirm({
        title: 'Подтвердить',
        content: '<p>Удалить текущую задачу?</p>',
        onOk: () => {
          deleteTask(taskid).then(() => {
            this.$Message.success('Успешно удалено!')
            this.loadData()
          })
        }
      })
      this.loadData()
    },
    linkAdded: function (link) {
      this.relation.next_tid = link.to
      this.relation.tid = link.from
      this.relation.cid = this.cid

      addRelation(this.relation).then((data) => {
        if (data === -1) {
          this.$Message.warning('Зацикливание，невозможно добавить')
          let linkIndex = this.config.links.findIndex(x => x.id === link.id)
          if (linkIndex > -1) {
            this.config.links.splice(linkIndex, 1)
          }
        } else {
          this.$Message.success('Успешно добавлено!')
          link.rid = data
        }
      })
    },
    linkBreak: function (link) {
      deleteRelation(link.rid).then(() => {
        this.$Message.success('Успешно удалено!')
      })
    },
    saveData: function () {
      putNodes(this.config.nodes).then(() => {
        this.$Message.success('Успешно сохранено!')
      })
    },

    isEmpty: function (val) {
      return !!((val === undefined || val == null || val.length <= 0))
    },
    putTask: function () {
      putTask(this.task).then(() => {
        this.$Message.success('Успешная операция!')
        this.loadData()
      })
    },
    loadData: function () {
      let cid = this.$route.params.cid
      this.task.cid = cid
      this.cid = cid
      getRelations(cid).then(data => {
        if (!this.isEmpty(data.nodes)) {
          this.config.nodes = this.convertNodes(data.nodes)
        }
        if (!this.isEmpty(data.links)) {
          this.config.links = this.convertLinks(data.links)
        }
      })
    }
  }
}
</script>

<style scoped>

</style>
